# RxIO
# by Eresse <eresse@eresse.net>

# External Includes
require 'socket'
require 'openssl'

# Monkey-Patch SSLServer Class
class OpenSSL::SSL::SSLServer

	# Provide non-blocking accept
	def accept_nonblock
		sock, = @svr.accept_nonblock
		begin
			ssl = OpenSSL::SSL::SSLSocket.new(sock, @ctx)
			ssl.sync_close = true
			ssl.accept if @start_immediately
			ssl
		rescue Exception => ex
			if ssl
				ssl.close
			else
				sock.close
			end
			raise ex
		end
	end
end
